Con  {rf joystick receiver object by Dave Ratcliff 'ratronic' 7/17/10
      for receiving values from joystick transmitted from computer
      uses either parallax #27981 rf receiver or #27982 transceiver
use rfbot2.bas (robotbasic) and either parallax #27980 transmitter or #27982 transceiver on computer with joystick
      
see Dat section of this program for cut and paste robotbasic program rfbot2.bas}
                                   
Var                                
  long x1, y1, z1, b1, stack[50]       
  
Obj
  io : "fullduplexserial"
  
Pub start(pin)
  io.start(pin, -1, %0100, 9600)
  cognew(joy,@stack)
  
Pub joy | cs, cs1, x2, y2, z2, b2
  x1 := 0
  y1 := 0
  z1 := 0
  b1 := 0
  io.rxflush
  repeat
    repeat                                                          
      if io.rx == "!"                                               
        if io.rx == "~"                                             
          if io.rx == "#"                                           
            if io.rx == "}"                                         
              x2 := io.rx        'x axis from joystick                      
              y2 := io.rx        'y  "    "     "                             
              z2 := io.rx        'z  "    "     "                             
              b2 := io.rx        'trigger buttons                              
              cs := io.rx        'received checksum                                  
              cs1 := (x2 + y2 + z2 + b2) & $ff  'calculate checksum             
              if cs1 == cs       'compare received / calculated checksum                                     
                x1 := x2 - 127   'joystick x from -127 to +127
                y1 := y2 - 127   'joystick y from -127 to +127
                z1 := z2 - 127   'joystick z from -127 to +127
                b1 := b2         'joystick trigger button can be 0, 1, 2, 4, 8, 16, 32, 64, 128                                    
              else
                quit             'calculated checksum didn't match received checksum

Pub x
  return x1                      'return joystick x value

Pub y
  return y1                      'return joystick y value

Pub z
  return z1                      'return joystick z value 

Pub b
  return b1                      'return joystick button pressed

Dat   'rfbot2.bas program (can cut and paste into robotbasic)

'     'joystick transmitter by Dave Ratcliff 'ratronic' 7/17/10
'     'use either parallax #27980 transmitter or #27982 transceiver
'
'     SetCommPort 3,br9600   'set com port where parallax transmitter or transceiver hooked to
'
'     loop:
'      Joystick 1,x,y,z,t
'      a = round(x*255)
'      b = round(y*255)
'      c = round(z*255)
'      cs = (a+b+c+t) & 255
'      serialout "!~#}",a,b,c,t,cs
'     goto loop:                                